<template>
  <v-container
    id="sale-storage"
    class="fill-height"
  >
    <base-material-input-screen
      style="width: 100%"
      color2="warning"
      color3="error"
      text2="Lưu & In"
      icon2="print"
      icon1="save"
      icon3="close"
      @action-1="saveOrder($event)"
      @action-2="printOrder($event)"
      @back-list="backList($event)"
    >
      <!-- Control -->
      <v-form ref="form">

        <!--  desktop -->
        <div v-if="!isMobile()">
          <v-row>
            <v-col
              cols="12"
              lg="12"
              class="pb-0 text-right"
            >
              <v-radio-group
                v-model="saleOrder.order_customer_type"
                row
              >
                <v-radio
                  label="Khách lẻ"
                  value="KL"
                />
                <v-radio
                  label="Khách sỉ"
                  value="KS"
                />
                <v-radio
                  label="CTV"
                  value="CTV"
                />
              </v-radio-group>
            </v-col>
          </v-row>

          <!-- THÔNG TIN KHÁCH hàng -->
          <v-row>
            <v-col
              cols="12"
              lg="12"
            >
              <div>
                <v-expansion-panels
                  v-model="panel"
                  :readonly="readonly"
                  multiple
                >
                  <!-- THONG TIN SAN PHAM -->
                  <v-expansion-panel>
                    <v-expansion-panel-header class="blue lighten-4 pt-0 pb-0">
                      <h3 class="pb-0">
                        THÔNG TIN SẢN PHẨM
                      </h3>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                      <!-- FORM THÔNG TIN -->
                      <v-row>
                        <v-col
                          cols="12"
                          md="1"
                          sm="4"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <v-text-field
                            v-if="!isMobile()"
                            ref="productCode"
                            v-model="selectProduct.product_code"
                            label="Mã SP"
                            class="text-center"
                            required
                            disabled
                            hide-details=""
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          md="3"
                          sm="5"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <v-autocomplete
                            ref="productName"
                            v-model="selectProduct.product_name"
                            :items="productCboList"
                            :search-input.sync="searchInput"
                            return-object
                            item-text="name"
                            label="Tên sản phẩm (*)"
                            @change="productChange($event)"
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          lg="1"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <v-autocomplete
                            ref="productDVT"
                            v-model="selectProduct.size"
                            :items="specs"
                            item-text="name"
                            item-value="id"
                            return-object
                            class="text-center"
                            label="ĐVT"
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          lg="2"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <vuetify-money
                            ref="productPrice"
                            v-model="selectProduct.price"
                            label="Đơn Giá"
                            class="text-right"
                            :options="optionsmoney"
                            hide-details=""
                            @focus="true"
                            @input="amountProduct()"
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          lg="1"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <vuetify-money
                            ref="productQty"
                            v-model="selectProduct.quanity"
                            label="Số Lượng"
                            class="text-right"
                            :options="optionsmoney"
                            hide-details=""
                            @input="amountProduct()"
                            @enter="enterClicked()"
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          md="2"
                          sm="4"
                          class="light-gray pb-0 pt-0 mb-0 pb-0"
                        >
                          <vuetify-money
                            ref="refThanhTien"
                            v-model="selectProduct.amount"
                            label="Thành Tiền"
                            class="text-right"
                            readonly
                            :options="optionsmoney"
                            hide-details=""
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          md="2"
                          sm="2"
                          class="text-right"
                        >
                          <v-btn
                            color="primary"
                            class="text-center"
                            height="35px"
                            @click="addProduct($event)"
                          >
                            <v-icon>
                              add
                            </v-icon>
                          </v-btn>
                        </v-col>
                      </v-row>
                      <!-- SẢN PHẨM ĐÃ CHỌN -->
                      <v-row>
                        <v-col
                          cols="12"
                          md="7"
                          class="light-gray pa-0 pl-4"
                        >
                          DANH SÁCH SẢN PHẨM
                        </v-col>
                        <v-col
                          cols="12"
                          md="12"
                          class="light-gray pa-0"
                        >
                          <v-data-table
                            v-model="selected"
                            :headers="headers"
                            :items="saleOrder.saleOrderDetail"
                            :single-select="singleSelect"
                            :hide-default-footer="true"
                            class="table-list table-list-2"
                            show-select
                            fixed-header
                            height="250"
                          >
                            <!-- Search -->
                            <!-- <template v-slot:top>
                              <v-text-field
                                v-model="search"
                                label="Tìm kiếm theo tên sản phẩm"
                                class="mx-4 pt-5 ma-0 pb-2"
                                hide-details=""
                              />
                            </template> -->
                            <!-- body -->
                            <template v-slot:item.size="{ item }">
                              {{ specs.filter(specs => specs.id === item.size).pop().name }}
                            </template>

                            <template v-slot:item.quanity="{ item }">
                              <vuetify-money
                                slot="input"
                                v-model="item.quanity"
                                :options="optionsqty"
                                hide-details=""
                              />
                              <!-- {{ formatPrice(item.quanity, 0) }} -->
                            </template>
                            <template v-slot:item.price="{ item }">
                              <vuetify-money
                                slot="input"
                                v-model="item.price"
                                :options="optionsqty"
                                hide-details=""
                              />
                            </template>
                            <template v-slot:item.amount="{ item }">
                              {{ formatPrice(item.amount, 0) }}
                            </template>
                            <template v-slot:item.action="{ item }">
                              <v-btn
                                color="gray"
                                class="text-center w-icon w-25"
                                icon
                                @click="editProduct(item)"
                              >
                                <v-icon
                                  medium
                                >
                                  mdi-arrow-up-bold
                                </v-icon>
                              </v-btn>
                              <v-btn
                                color="red"
                                class="text-center w-icon w-25"
                                icon
                                @click="deleteProduct(item)"
                              >
                                <v-icon
                                  medium
                                >
                                  delete
                                </v-icon>
                              </v-btn>
                            </template>
                          </v-data-table>
                        </v-col>
                      </v-row>
                    </v-expansion-panel-content>
                  </v-expansion-panel>
                  <!--  THONG TIN SAN PHAM END -->

                  <!--  THONG TIN KHÁCH HÀNG -->
                  <v-expansion-panel>
                    <v-expansion-panel-header class="blue lighten-4 pt-0 pb-0">
                      <v-row>
                        <v-col
                          cols="12"
                          lg="7"
                        >
                          <h3 class="pb-0">
                            THÔNG TIN KHÁCH HÀNG - GIAO HÀNG
                          </h3>
                        </v-col>
                      </v-row>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                      <v-row>
                        <!-- Nguoi mua -->
                        <v-col
                          cols="12"
                          md="4"
                          class="light-gray pb-0 pt-0"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-combobox
                                ref="customerOrder"
                                v-model="saleOrder.customer_name"
                                :items="customerList"
                                search-input="KH Lẻ"
                                return-object
                                item-text="name"
                                label="Khách hàng (*)"
                                :rules="nameRules"
                                required
                                clearable
                                @input="customerChange($event)"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="6"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="customerPhone"
                                v-model="saleOrder.customer_phone"
                                label="Số ĐT"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="6"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="customerAddress"
                                v-model="saleOrder.order_code"
                                label="Ngày mua"
                                required
                                disabled
                              />
                            </v-col>

                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.customer_address"
                                label="Địa chỉ"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        <!-- Nguoi nhận -->
                        <v-col
                          cols="12"
                          md="4"
                          class="light-gray pb-0 pt-0"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-autocomplete
                                ref="customerdeliveryname"
                                v-model="saleOrder.name_delivery"
                                :items="customerList"
                                :rules="nameRules"
                                return-object
                                item-text="name"
                                label="Họ tên người nhận (*)"
                                search-input.sync="KH LẺ"
                                required
                                clearable
                                @change.native="customerChange($event)"
                                @input="customerChange($event)"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="7"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.phone_delivery"
                                label="ĐT giao hàng"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="5"
                              class="light-gray pb-0 pt-0 mb-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.time_delivery"
                                label="Thời gian giao hàng"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.address_delivery"
                                label="Địa chỉ"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        <!-- DVVC -->
                        <v-col
                          cols="12"
                          md="3"
                          class="light-gray pb-0 pt-0"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-autocomplete
                                ref="refDVVC"
                                v-model="saleOrder.delivery_partner"
                                :items="DVVCList"
                                :rules="nameRules"
                                return-object
                                item-text="name"
                                label="ĐVVC"
                                search-input.sync="GHN"
                                required
                                clearable
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.delivery_tracking"
                                label="Mã vận đơn"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pb-0 pt-0"
                            >
                              <v-text-field
                                ref="refdelUrl"
                                v-model="saleOrder.delivery_url"
                                label="Link"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        <!-- END DVVC  -->
                        <v-col
                          cols="12"
                          lg="1"
                          class="text-center"
                        >
                          <v-row class="text-center">
                            <v-col>
                              <v-btn
                                color="green"
                                icon
                                @click="insertCustomer(item)"
                              >
                                <v-icon
                                  large
                                >
                                  add
                                </v-icon>
                              </v-btn>
                            </v-col>
                          </v-row>
                          <v-row class="text-center">
                            <v-col>
                              <v-btn
                                color="green"
                                icon
                                @click="copyCustomer(item)"
                              >
                                <v-icon
                                  large
                                >
                                  file_copy
                                </v-icon>
                              </v-btn>
                            </v-col>
                          </v-row>
                        </v-col>
                        <v-col
                          cols="12"
                          lg="12"
                          class="light-gray pb-0 pt-0 mt-0"
                        >
                          <v-textarea
                            ref="refNotes"
                            v-model="saleOrder.note"
                            rows="1"
                            label="Ghi chú"
                            class="font-2em"
                            clearable
                          />
                        </v-col>
                      </v-row>
                    </v-expansion-panel-content>
                  </v-expansion-panel>
                  <!--  THONG TIN KHÁCH HÀNG END -->
                </v-expansion-panels>
              </div>
            </v-col>
          </v-row>

          <!-- total -->
          
          <v-row class="order-fixed-footer">
            <v-col
              cols="12"
              md="12"
              lg="12"
              class="text-right justify-center pt-1 pb-0 mb-0"
            >
              <div class="title blue lighten-4  mb-0 pr-5">
                Tổng Tiền: <span style="color:red; font-size: 16pt"> {{ formatPrice(saleOrder.total, 0) }} </span>
              </div>
            </v-col>
          </v-row>
          <!-- total end -->
        </div>
        <!-- //End desktop -->

        <!-- isMobile -->
        <div v-else>
        <v-row>
            <v-col
              cols="12"
              lg="12"
              class="pb-0 text-right"
              style="height:50px"
            >
              <v-radio-group
                v-model="saleOrder.order_customer_type"
                row
              >
                <v-radio
                  label="Khách lẻ"
                  value="KL"
                />
                <v-radio
                  label="Khách sỉ"
                  value="KS"
                />
                <v-radio
                  label="CTV"
                  value="CTV"
                />
              </v-radio-group>
            </v-col>
          </v-row>

          <!-- THÔNG TIN KHÁCH hàng -->
          <v-row>
            <v-col
              cols="12"
              lg="12"
            >
              <div>
                <v-expansion-panels
                  v-model="panel"
                  :readonly="readonly"
                  multiple
                >
                  <!-- THONG TIN SAN PHAM -->
                  <v-expansion-panel>
                    <v-expansion-panel-header class="blue lighten-4 pt-0 pb-0">
                      <h3 class="pb-0">
                        SẢN PHẨM
                      </h3>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                      <!-- FORM THÔNG TIN -->
                      <v-row>
                        <v-col
                          cols="12"
                          md="12"
                          class="light-gray pa-1 pa-1 mb-0"
                        >
                          <v-autocomplete
                            ref="productName"
                            v-model="selectProduct.product_name"
                            :items="productCboList"
                            :search-input.sync="searchInput"
                            return-object
                            item-text="name"
                            label="Tên sản phẩm (*)"
                            @change="productChange($event)"
                          >
                           <!-- <template v-slot:selection="data">
                            <v-chip
                              v-bind="data.attrs"
                              :input-value="data.selected"
                              close
                              @click="data.select"
                              @click:close="remove(data.item)"
                            >
                              <v-avatar left>
                                <v-img :src="data.item.avatar"></v-img>
                              </v-avatar>
                              {{ data.item.name }}
                            </v-chip>
                          </template> -->
                            <template v-slot:item="data">
                              <template v-if="typeof data.item !== 'object'">
                                <v-list-item-content v-text="data.item"></v-list-item-content>
                              </template>
                              <template v-else>
                                <v-list-item-avatar>
                                  <img :src="JSON.parse(data.item.img_url).thumbs">
                                </v-list-item-avatar>
                                <v-list-item-content>
                                  <v-list-item-title class="text-bold">
                                    <v-row>
                                      <v-col cols="8">{{data.item.name}}</v-col
                                      ><v-col cols="4" class="text-right">
                                        {{
                                          formatPrice(data.item.wholesale_price, 0) 
                                        }}</v-col>
                                      </v-row>
                                  </v-list-item-title>
                                  <v-list-item-subtitle >Kho: {{data.item.quatity_inventory}}</v-list-item-subtitle>
                                 
                                </v-list-item-content>
                              </template>
                            </template>
                          </v-autocomplete>
                        </v-col>
                        <v-col
                          cols="6"
                          class="light-gray pa-1 pa-1 mb-0"
                          v-show="false"
                        >
                          <v-text-field
                            ref="productCode"
                            v-model="selectProduct.product_code"
                            label="Mã SP"
                            class="text-center"
                            required
                            disabled
                            hide-details=""
                          />
                        </v-col>
                        <v-col
                          cols="6"
                          class="light-gray pa-1 pa-1 mb-0"
                          v-show="false"
                        >
                          <v-autocomplete
                            ref="productDVT"
                            v-model="selectProduct.size"
                            :items="specs"
                            item-text="name"
                            item-value="id"
                            return-object
                            label="ĐVT"
                          />
                        </v-col>
                        <v-col
                          sm="4"
                          class="light-gray pa-1 pa-1 mb-0"
                          v-show="false"
                        >
                          <vuetify-money
                            ref="productPrice"
                            v-model="selectProduct.price"
                            label="Đơn Giá"
                            class="text-right"
                            :options="optionsmoney"
                            hide-details=""
                            @focus="true"
                            @input="amountProduct()"
                          />
                        </v-col>
                        <v-col
                          sm="4"
                          class="light-gray pa-1 pa-1 mb-0"
                          v-show="false"
                        >
                          <vuetify-money
                            ref="productQty"
                            v-model="selectProduct.quanity"
                            label="Số Lượng"
                            class="text-right"
                            :options="optionsmoney"
                            hide-details=""
                            @input="amountProduct()"
                            @enter="enterClicked()"
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          md="2"
                          sm="4"
                          class="light-gray pa-1 pa-1 mb-0"
                          v-show="false"
                        >
                          <vuetify-money
                            ref="refThanhTien"
                            v-model="selectProduct.amount"
                            label="Thành Tiền"
                            class="text-right"
                            readonly
                            :options="optionsmoney"
                            hide-details=""
                          />
                        </v-col>
                        <v-col
                          cols="12"
                          md="2"
                          sm="2"
                          class="text-right"
                          v-show="false"
                        >
                          <v-btn
                            color="primary"
                            class="text-center"
                            height="35px"
                            @click="addProduct($event)"
                          >
                            <v-icon>
                              add
                            </v-icon>
                          </v-btn>
                        </v-col>
                      </v-row>
                      <!-- SẢN PHẨM ĐÃ CHỌN -->
                      <v-row>
                        <v-list subheader>
                          <v-subheader>
                            <v-row>
                              <v-col col="12" class="ma-0 pa-0">
                                <h2>Mặt hàng đã chọn {{saleOrder.saleOrderDetail.length}}</h2>
                              </v-col>
                            </v-row>
                          </v-subheader>
                          <v-divider />
                          <swipe-list
                            ref="list"
                            class="card"
                            :disabled="!enabled"
                            :items="mockSwipeList"
                            item-key="id"
                            @swipeout:click="itemClick"
                          >
                            <template v-slot="{ item, index, revealLeft, revealRight, close }">
                              <!-- item is the corresponding object from the array -->
                              <!-- index is clearly the index -->
                              <!-- revealLeft is method which toggles the left side -->
                              <!-- revealRight is method which toggles the right side -->
                              <!-- close is method which closes an opened side -->
                              <div class="card-content">
                                <!-- style content how ever you like -->
                                <h2>{{ item.title }}</h2>
                                <p>{{ item.description }}</p>
                                <span>{{ index }}</span>
                              </div>
                            </template>
                            <!-- left swipe side template and v-slot:left="{ item }" is the item clearly -->
                            <!-- remove if you dont wanna have left swipe side  -->
                            <template v-slot:left="{ item, close }">
                              <div class="swipeout-action red" title="remove" @click="remove(item)">
                                <!-- place icon here or what ever you want -->
                                <i class="mdi-arrow-up-bold"></i>
                              
                              </div>
                              <div class="swipeout-action purple" @click="close">
                                <!-- place icon here or what ever you want -->
                                <i class="fa fa-close"></i>
                              </div>
                            </template>
                            <!-- right swipe side template and v-slot:right"{ item }" is the item clearly -->
                            <!-- remove if you dont wanna have right swipe side  -->
                            <template v-slot:right="{ item }">
                              <div class="swipeout-action gray">
                                <v-icon color="white">
                                  mdi-trash
                                </v-icon>
                                <!-- place icon here or what ever you want -->
                                
                              </div>
                              <div class="swipeout-action text-center red pa-4">
                                <v-icon color="white">
                                  mdi-delete
                                </v-icon>
                                <!-- place icon here or what ever you want -->
                                <!-- <i class="fa fa-heart"></i> -->
                              </div>
                            </template>
                            <template v-slot:empty>
                              <div>
                                <!-- change mockSwipeList to an empty array to see this slot in action  -->
                                list is empty ( filtered or just empty )
                                abc
                              </div>
                            </template>
                          </swipe-list>
                          <v-list-item
                            v-for="detail in saleOrder.saleOrderDetail"
                            :key="detail.product_code"
                            class="pa-0"
                          >
                            <v-list-item-avatar>
                              <v-img
                                width="70px"
                                height="70px"
                                :alt="`${detail.product_name} avatar`"
                                src="https://cdn.vuetifyjs.com/images/lists/1.jpg"
                              ></v-img>
                            </v-list-item-avatar>

                            <v-list-item-content>
                              
                                  <div><h3>{{ detail.product_name }} </h3></div>
                                  <div class="pt-1">
                                    <!-- <h3 style="color:red">{{ formatPrice(detail.price, 0)}}</h3> -->
                                    <v-row>
                                      <v-col col="8" class="">
                                        Giá
                                      </v-col>
                                      <v-col col="4" class="ma-0 pa-0">
                                        SL
                                      </v-col>
                                    </v-row>
                                    <v-row>
                                      <v-col col="8" class="">
                                         <vue-numeric-input 
                                          v-model="detail.price" 
                                          :min="1000" :max="1000000" 
                                          :step="100" 
                                          align="center"
                                          class="text-price"
                                          @change="itemQtyChange(this)"></vue-numeric-input>
                                      </v-col>
                                      <v-col col="4" class="ma-0 pa-0">
                                       <vue-numeric-input 
                                        v-model="detail.quanity" 
                                        :min="1" :max="1000" 
                                        :step="1" 
                                        align="center"
                                        class="text-qty"
                                        @change="itemQtyChange(this)"></vue-numeric-input>
                                      </v-col>
                                    </v-row>
                                  </div>
                            </v-list-item-content>

                            <v-list-item-icon class="right">
                              <v-icon color="red" large @click="deleteProduct(detail)">
                                mdi-close
                              </v-icon>
                            </v-list-item-icon>
                          </v-list-item>
                          
                        </v-list>
                      </v-row>
                    </v-expansion-panel-content>
                  </v-expansion-panel>
                  <!--  THONG TIN SAN PHAM END -->

                  <!--  THONG TIN KHÁCH HÀNG -->
                  <v-expansion-panel>
                    <v-expansion-panel-header class="blue lighten-4 pt-0 pb-0">
                      <v-row>
                        <v-col
                          cols="12"
                          lg="7"
                        >
                          <h3 class="pb-0">
                            KHÁCH HÀNG - GIAO HÀNG
                          </h3>
                        </v-col>
                      </v-row>
                    </v-expansion-panel-header>
                    <v-expansion-panel-content>
                      <v-row>
                        <!-- Nguoi mua -->
                        <v-col
                          cols="12"
                          md="4"
                          class="light-gray pa-1 "
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 "
                            >
                              <v-combobox
                                ref="customerOrder"
                                v-model="saleOrder.customer_name"
                                :items="customerList"
                                search-input="KH Lẻ"
                                return-object
                                item-text="name"
                                label="Khách hàng (*)"
                                :rules="nameRules"
                                required
                                clearable
                                @input="customerChange($event)"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="6"
                              class="light-gray pa-1 "
                            >
                              <v-text-field
                                ref="customerPhone"
                                v-model="saleOrder.customer_phone"
                                label="Số ĐT"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="6"
                              class="light-gray pa-1 btn-control-detail"
                            >
                              <v-text-field
                                ref="customerAddress"
                                v-model="saleOrder.order_code"
                                label="Ngày mua"
                                required
                                disabled
                              />
                            </v-col>

                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1 "
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.customer_address"
                                label="Địa chỉ"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        
                        <v-col
                          cols="12"
                          class="text-right pa-0 ma-0"
                        >
                          <v-btn
                            color="green"
                            icon
                            @click="insertCustomer(item)"
                          >
                            <v-icon
                            >
                              add
                            </v-icon>
                          </v-btn>
                            <v-btn
                            color="green"
                            icon
                            @click="copyCustomer(item)"
                          >
                            <v-icon
                            >
                              file_copy
                            </v-icon>
                          </v-btn>
                        </v-col>
                        <!-- Nguoi nhận -->
                        <v-col
                          cols="12"
                          md="4"
                          class="light-gray pa-1 pa-1"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-autocomplete
                                ref="customerdeliveryname"
                                v-model="saleOrder.name_delivery"
                                :items="customerList"
                                :rules="nameRules"
                                return-object
                                item-text="name"
                                label="Họ tên người nhận (*)"
                                search-input.sync="KH LẺ"
                                required
                                clearable
                                @change.native="customerChange($event)"
                                @input="customerChange($event)"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="7"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.phone_delivery"
                                label="ĐT giao hàng"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="5"
                              class="light-gray pa-1 pa-1 mb-0"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.time_delivery"
                                label="Thời gian giao hàng"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.address_delivery"
                                label="Địa chỉ"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        <v-divider></v-divider>
                        <!-- DVVC -->
                        <v-col
                          cols="12"
                          md="3"
                          class="light-gray pa-1 pa-1"
                        >
                          <v-row>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-autocomplete
                                ref="refDVVC"
                                v-model="saleOrder.delivery_partner"
                                :items="DVVCList"
                                :rules="nameRules"
                                return-object
                                item-text="name"
                                label="ĐVVC"
                                search-input.sync="GHN"
                                required
                                clearable
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-text-field
                                ref="codeproduct"
                                v-model="saleOrder.delivery_tracking"
                                label="Mã vận đơn"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                            <v-col
                              cols="12"
                              lg="12"
                              class="light-gray pa-1 pa-1"
                            >
                              <v-text-field
                                ref="refdelUrl"
                                v-model="saleOrder.delivery_url"
                                label="Link"
                                required
                                :rules="nameRules"
                              />
                            </v-col>
                          </v-row>
                        </v-col>
                        <!-- END DVVC  -->
                         <v-col
                          cols="12"
                          lg="12"
                          class="light-gray pa-1 pa-1"
                        >
                          <v-textarea
                            ref="refNotes"
                            v-model="saleOrder.note"
                            rows="1"
                            label="Ghi chú"
                            class="font-2em"
                            clearable
                          />
                        </v-col>
                      
                       
                      </v-row>
                    </v-expansion-panel-content>
                  </v-expansion-panel>
                  <!--  THONG TIN KHÁCH HÀNG END -->
                </v-expansion-panels>
              </div>
            </v-col>
          </v-row>

          <!-- total -->
          <v-row class="order-fixed-footer">
            <v-col
              cols="12"
              md="12"
              lg="12"
              class="text-right justify-center pt-1 pb-0 mb-0"
            >
              <div class="title blue lighten-4  mb-0 pr-5">
                Tổng Tiền:<span style="color:red; font-size: 16pt"> {{ formatPrice(saleOrder.total, 0) }} </span>
              </div>
            </v-col>
          </v-row>
          <!-- total end -->
        </div>
        <!-- End isMobile -->
      </v-form>
    </base-material-input-screen>
    <!-- dialog -->
    <v-row>
      <dialogConfirm
        ref="dialogConfirm"
        :v-model="dialogConfirm"
      />
    </v-row>

    <v-row>
      <dialogAlert
        ref="dialogAlert"
        :v-model="dialogAlert"
      />
    </v-row>

    <v-row>
      <snackbarNew
        ref="snackNotification"
        :v-model="snackbar"
      />
    </v-row>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'
  import snackbarNew from '../dashboard/component/snackbarNew'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'
  import totalOrder from '../sales/TotalOrder'
  import VueNumericInput from 'vue-numeric-input'
  import { SwipeList, SwipeOut } from 'vue-swipe-actions'
  import 'vue-swipe-actions/dist/vue-swipe-actions.css'

  export default {
    layout: 'addstorage',
    components: {
      snackbarNew,
      dialogConfirm,
      dialogAlert,
      totalOrder,
      VueNumericInput,
      SwipeOut,
      SwipeList,
    },
    data () {
      return {
        readonly: false,
        disabled: false,
        outlined: true,
        clearable: true,
        valueWhenIsEmpty: '0.00',
        optionsmoney: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
        optionsqty: {
          locale: 'pt-BR',
          prefix: '',
          suffix: '',
          length: 11,
          precision: 0,
        },
        search: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStorage: false,
        dialogConfirm: false,
        dialogAlert: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        column: null,
        row: null,
        ipm_value: 1,
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        searchDVT: '',
        searchInput: '',
        imageStore1: 'https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d',
        specs: [],
        panel: [0, 1, 2],
        selectProduct: {
        },
        customerModel: {
          code: '',
          name: '',
          phone: '',
          address: '',
          delivery_name: '',
          delivery_address: '',
          delivery_phone: '',
          delivery_time: '',
        },
        customerList: [],
        productCboList: [
        ],
        productList: [
        ],
        DVVCList: [],
        saleOrder: {
          order_code: '12-12-2020',
          order_customer_type: 'KL',
          customer_name: { id: 5, name: 'KH LẺ' },
          customer_code: '6',
          customer_address: 'Tp.HCM',
          customer_phone: '',
          name_delivery: '',
          address_delivery: 'Tp.HCM',
          phone_delivery: '',
          note: '',
          time_delivery: '',
          customer_id: '',
          create_user: '1',
          total: 0,
          saleOrderDetail: [
          ],
        },
        headers: [
          {
            text: 'MÃ HÀNG',
            sortable: false,
            value: 'product_code',
            align: 'center',
            width: '90',
          },
          {
            text: 'TÊN HÀNG',
            sortable: false,
            value: 'product_name',
          },
          {
            text: 'ĐVT',
            sortable: false,
            value: 'size',
            width: '120',
            align: 'center',
          },
          {
            text: 'GIÁ BÁN',
            value: 'price',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
            width: '150',
          },
          {
            text: 'SỐ LƯỢNG',
            value: 'quanity',
            format: (v) => v && Number(v).toFixed(0),
            align: 'right',
            width: '120',
          },
          {
            text: 'THÀNH TIỀN',
            value: 'amount',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
            width: '200',
          },
          {
            text: '',
            sortable: false,
            align: 'center',
            value: 'action',
            width: '100',
          },
        ],
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: ['NCC1'],
        category: [],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productStorageModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          net: '',
          wholesale_price: '0',
          retail_price: '0',
          quota_whosale: '0',
          quatity_inventory: '0',
          note: '',
          img_url: '{ "A": "B" }',
          real_price: '0',
          create_user: '1',
          receipt_suppiler: '',
        },
        nameRules: [(v) => !!v || 'The field is required'],
        numberRule: [(v) => !!v || 'The field is required'],
        priceRule: [(v) => !!v || 'The field is required'],
        specRule: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
        recent: [
        {
          active: true,
          avatar: 'https://cdn.vuetifyjs.com/images/lists/1.jpg',
          title: 'Jason Oner',
        },
        {
          active: true,
          avatar: 'https://cdn.vuetifyjs.com/images/lists/2.jpg',
          title: 'Mike Carlson',
        },
        {
          avatar: 'https://cdn.vuetifyjs.com/images/lists/3.jpg',
          title: 'Cindy Baker',
        },
        {
          avatar: 'https://cdn.vuetifyjs.com/images/lists/4.jpg',
          title: 'Ali Connors',
        },
        ],

        // Swipe
        enabled: true,
        mockSwipeList: [
          {
            id: 0,
            title: "Some title",
            description: "some description"
          },
          {
            id: 1,
            title: "Some title",
            description: "some description"
          },
          {
            id: 2,
            title: "Some title",
            description: "some description"
          }
        ],
        // End Swipe

        //Tab
        tab: 0,
        tabs: [
          { name: "Mặt hàng", icon: "mdi-cart-plus" },
          { name: "Vận chuyển", icon: "mdi-truck-delivery" },
          { name: "Thanh toán", icon: "mdi-cash" },
        ],
        //End Tab

      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {
      this.getProductList()
      this.getSpecs()
      this.getCategories()
      this.getCustomerList()
      this.selectDVVC()
    }, // end data
    methods: {
      isMobile() {
        if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
      isNull (object) {
        console.log(object)
        if (
          object === undefined ||
          object === null ||
          object === '') {
          return true
        }
        return false
      },
      validate () {
        const flag = true
        return this.$refs.form.validate()
        // this.$nextTick(function () {
        //   // Product name

        //   if (!this.$refs.receiptquatity.validate()) {
        //     flag = false
        //     this.$refs.receiptquatity.focus()
        //   } else if (!this.$refs.receiptprice.validate()) {
        //     flag = false
        //     this.$refs.receiptprice.focus()
        //   } else if (!this.$refs.receipspec.validate()) {
        //     flag = false
        //     this.$refs.receipspec.focus()
        //   }

        //   // //Ton kho toi thieu
        //   // else if(!this.$refs.qtyinventory.validate()){
        //   //   this.$refs.qtyinventory.focus();
        //   // }
        //   // else if (!this.$refs.category.validate()) {
        //   //   flag = false;
        //   //   this.$refs.category.focus();
        //   // } else if (!this.$refs.suppiler.validate()) {
        //   //   flag = false;
        //   //   this.$refs.suppiler.focus();
        //   // }
        //   return flag
        // })
      },
      quantity(type){
        // alert(type);
      },
      async insertStorage () {
        // console.log("Valid store ok:" + this.validate());
        // eslint-disable-next-line no-unused-vars
        const chitieu = JSON.stringify(this.chitieuModel)
        const seft = this
        this.productStorageModel.note = JSON.stringify({
          note: this.productStorageModel.note,
        })
        this.productStorageModel.specification = JSON.stringify({
          DVT: this.productStorageModel.specification,
        })
        this.productStorageModel.receipt_suppiler = JSON.stringify({
          NCC: this.productStorageModel.receipt_suppiler,
        })
        // this.productStorageModel.previous_price = this.productStorageModel.real_price;
        await axios
          .post(
            config.API_FAMILY + '/api/insertStorage',
            this.productStorageModel,
          )
          .then(function (response) {
            seft.dialog = false
            console.log('Valid store ok')
            console.log(response.data.data)
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      productChange (object) {
        const seft = this
        this.selectProduct.product_code = object.code
        this.selectProduct.price = object.retail_price
        if (object !== undefined &&
          object.specification !== undefined) {
          // this.specs = object.specification
          // debugger
          this.selectProduct.size = object.specification
        }
        console.log('Spec find by ID')
        console.log(this.specs)
        console.log('Product select')
        console.log(object);
        console.log('order_customer_type')
        console.log(this.saleOrder.order_customer_type);
        if(this.saleOrder.order_customer_type != undefined){
          if('KL' == this.saleOrder.order_customer_type){
            this.selectProduct.price = object.retail_price;

          }else if('KS' == this.saleOrder.order_customer_type){
            this.selectProduct.price = object.wholesale_price;
          }
        }
        this.selectProduct.quanity = 1;
        // this.selectProduct.amount = this.selectProduct.quanity * this.selectProduct.price
        const specObj = this.specs.filter(specs => specs.id === this.selectProduct.size).pop()
        console.log('found_names: ' + this.specs.filter(specs => specs.id === this.selectProduct.size).pop().name + ' : ' + this.selectProduct.size)

        this.addProduct();
      // quatity_inventory
      },
      amountProduct () {
        this.selectProduct.amount = this.selectProduct.quanity * this.selectProduct.price
        console.log(this.selectProduct)
      },
      itemQtyChange(obj){
        console.log('itemQtyChange')
        console.log(obj)
        this.updateTotal()
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log('Spec')
            console.log(response.data.data)
            seft.specs = response.data.data
          })
      },
      async getProductList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getListProduct')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.productCboList = response.data.data
          })
      },
      async getCustomerList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCustomers')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.customerList = response.data.data
          })
      },
      addProduct ($event) {
        const self = this
        if (this.selectProduct !== undefined &&
          this.selectProduct.product_code !== undefined &&
          this.selectProduct.product_code !== '') {
          // Check null DVT, Gia, SL
          if (this.isNull(this.selectProduct.size)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập đơn vị tính')
            this.$nextTick(function () {
              self.$refs.productDVT.focus()
            })
          } else if (this.isNull(this.selectProduct.price)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập giá bán')
            this.$nextTick(function () {
              this.$refs.productPrice.focus()
            })
          } else if (this.isNull(this.selectProduct.quanity)) {
            this.snackbaralert(this.colors[4], 'Bạn chưa nhập số lượng')
            this.$nextTick(function () {
              self.$refs.productQty.focus()
            })
          } else if (this.selectProduct.quanity <= 0) {
            this.snackbaralert(this.colors[4], 'Số lượng phải lớn hơn 0')
          } else {
            // Kiem tra tồn tại
            var count = 0
            var isExist = this.saleOrder.saleOrderDetail.filter(client => {
              console.log('client')
              console.log(client);
              if (client.product_code.toLowerCase() == self.selectProduct.product_code.toLowerCase() &&
                client.selectProduct.size == self.selectProduct.size) {
                count++
              }
            })
            if (count > 0) {
              this.snackbaralert(this.colors[4], 'Vui lòng cập nhật lại SL và Đơn giá')
              return
            }
            this.amountProduct()
            var productItem = this.selectProduct
            productItem.product_name = this.selectProduct.product_name.name
            this.saleOrder.saleOrderDetail.push(productItem)
            this.updateTotal()
            console.log('addProduct')
            console.log(productItem)
            this.selectProduct = {}
            this.$nextTick(function () {
              this.$refs.productName.focus()
            })
          }
        } else {
          this.snackbaralert(this.colors[4], 'Bạn chưa chọn mặt hàng')
          this.$nextTick(function () {
            this.$refs.productName.focus()
          })
        }
      },
      deleteProduct (item) {
        console.log('deleteProduct')
        console.log(item)
        this.saleOrder.saleOrderDetail.pop(item)
        this.updateTotal()
      },
      editProduct (item) {
        console.log('editProduct')
        // update current total
        item.amount = item.quanity * item.price
        this.updateTotal()
        console.log(item)
      },
      updateTotal () {
        // Total
        let total = 0
        console.log('For each')
         console.log(this.saleOrder.saleOrderDetail);
        this.saleOrder.saleOrderDetail.forEach((object, idx) => {
          total += (object.price *  object.quanity)
        })
        this.saleOrder.total = total
      },
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },
      customerChange (object) {
        console.log('customerChange')
        console.log(object)
        // this.$refs.customerCode.text = object.id
        this.saleOrder.customer_phone = object.phone_number
        this.saleOrder.customer_address = object.address

        // this.productStorageModel.product_code = object.code
        // this.productStorageModel.quatity_inventory = object.quatity_inventory
        // this.productStorageModel.category_code = object.category_code
        // this.productStorageModel.suppiler_code = object.suppiler_code

        // this.productStorageModel.previous_price = object.real_price
        // this.productStorageModel.stock_current = object.quatity_inventory
      },

      async insertCustomer (item) {
        const seft = this
        const customer = {
          name: this.saleOrder.customer_name,
          address: 'New Addesss',
          phone_number: this.saleOrder.customer_phone,
          address_final_orderm: 'address_final_orderm new',
          note: 'New note',
        }
        await axios
          .post(
            config.API_FAMILY + '/api/insertCustomer',
            customer,
          )
          .then(function (response) {
            seft.getCustomerList()
            seft.snackbaralert(this.colors[4], 'Đã thêm mới khách hàng')
          })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = (e) => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
      enterClicked () {
        alert('enterClicked')
      },
      trigger () {
        // this.$refs.sendReply.click()
      },
      printOrder ($event) {
        console.log('prnt')
        console.log(this.saleOrder.saleOrderDetail)
      },
      async saveOrder ($event) {
        const seft = this
        if (this.validate()) {
          console.log('saleOrder')
          // this.saveOrder
          console.log(this.saleOrder)
          console.log(this.saleOrder.saleOrderDetail)
          await axios
            .post(
              config.API_FAMILY + '/api/insertOrder',
              this.saleOrder,
            )
            .then(function (response) {
              console.log('Valid store ok')
              console.log(response.data.data)
              seft.$router.push({ name: 'DANH SÁCH ĐƠN HÀNG' })
            })
        }
      },
      async selectDVVC () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/selectDVVC')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.DVVCList = response.data.data
          })
      },
      backList ($event) {
        this.$router.push({ name: 'DANH SÁCH ĐƠN HÀNG' })
      },
      copyCustomer (item) {
        this.saleOrder.name_delivery = this.saleOrder.customer_name
        this.saleOrder.phone_delivery = this.saleOrder.customer_phone
      },

      // Swipe
      revealFirstRight() {
        this.$refs.list.revealRight(0);
      },
      revealFirstLeft() {
        this.$refs.list.revealLeft(0);
      },
      closeFirst() {
        this.$refs.list.closeActions(0);
      },
      closeAll() {
        this.$refs.list.closeActions();
      },
      remove(item) {
        this.mockSwipeList = this.mockSwipeList.filter(i => i !== item);
        // console.log(e, 'remove');
      },
      itemClick(e) {
        console.log(e, "item click");
      },
      fbClick(e) {
        console.log(e, "First Button Click");
      },
      sbClick(e) {
        console.log(e, "Second Button Click");
      },
      // End Swipe
    }, // end method
  } // End exxport default
</script>
<style scroped>

.btn-control-detail .v-btn--icon.v-size--default{
  height: 25px;
  width: 25px;
}
.text-price input, .text-qty input{

  color: red;
  font-weight: bold;
  
}
</style>
